﻿#include <cstdio>
#include <cmath>
using namespace std;

#define PI 3.14159265358979323846

typedef double (*YourFunction)(double); // Определяем указатель на функцию от одной переменной типа double, и возвращающей значение типа double

double TrapezRule(const YourFunction f, double a, double b, int n) // Формула трапеции для функции f на отрезке [a, b], разбитом на n частей
{
   double h = (b - a)/n;
   double result = 0;
   for(int i = 1; i <= n; i++)
   {
      result += (*f)(a + (i - 1) * h) + (*f)(a + i * h); // a + i * h - это i-я точка разбиения
   }
   return h/2 * result;
}

double MyFunction(double x)
{
   return sin(x); // Функция из примера
}

int main()
{
   printf("%.9f\n", TrapezRule(MyFunction, 0, PI/4, 10)); // Выводим ответ с 9 цифрами после точки
   return 0;
}

